Subject: Re: git fails on large repo clone on intermittent, or intermittently-high-latency, connections

From: Jakub Narebski <[email-masked]>
Date: Wed, 5 Jan 2011 21:00:48 +0100

On Wed, 5 Jan 2011, Jonathan Nieder wrote:
> Jakub Narebski wrote:
> > Zenaan Harkness <[email-masked]> writes:
> 
> > > How hard would it be to add a wget-like mode to git, for the initial
> > > repo download?
> >
> > Very hard; tthough "resumable clone" was often requested (25%
> > responders in "Git User's Survey 2010", see [1]), and there was even
> > some discussion about possible implementation, it was not implemented
> > yet, even as proof of concept.
> >
> > The trouble is that packfile is *generated for a client*, and
> > bit-for-bit representation of said pack can vary (e.g. if
> > multithreaded packing is enabled; usually a good idea).
> 
> That said, one possible partial solution would be to automate
> generation of a seed bundle for huge repositories (with a script or
> a special parameter to "git gc", maybe) and to document serving such a
> seed bundle over HTTP as part of the standard setup.  If this could be
> made simple enough that e.g. all large repos on repo.or.cz had such a
> seed bundle then I would call it a success. :)

I wonder if adding support for per-project _bundle_ link and 'bundle'
action support to gitweb (perhaps only if caching is turned on) would
help there... though I am not sure if doenloading fron gitweb is
resumable.

-- 
Jakub Narebski
Poland